/*
 * TreeSettings.h
 *
 *  Created on: 26. 3. 2014
 *	  Author: Jan Travnicek
 */

#ifndef __TREE_SETTINGS_H__
#define __TREE_SETTINGS_H__

#include "SettingsHelper.h"

class TreeEnum {
public:
	enum class Settings {
		ALPHABET, CONTENT, SUBTREE_WILDCARD, NONLINEAR_VARIABLES, __MAX__
	};

	static std::string toString ( TreeEnum::Settings settings ) {
		switch ( settings ) {
		case TreeEnum::Settings::ALPHABET:
			return "alphabet";

		case TreeEnum::Settings::CONTENT:
			return "content";

		case TreeEnum::Settings::SUBTREE_WILDCARD:
			return "subtree_wildcard";

		case TreeEnum::Settings::NONLINEAR_VARIABLES:
			return "nonlinear_variables";

		case TreeEnum::Settings::__MAX__:
			throw exception::CommonException ( "Invalid enumeration" );
		}
		throw exception::CommonException ( "Invalid enumeration" );
	}

};

class TreeSettings : public TreeEnum, public EnumClassHelper < TreeEnum > {
};

#endif /* __TREE_SETTINGS_H__ */
