/*
 * ToPostfixPushdownAutomaton.h
 *
 *  Created on: 13. 3. 2017
 *	  Author: Stepan Plachy
 */

#ifndef AUTOMATON_TO_AUTOMATON_H_
#define AUTOMATON_TO_AUTOMATON_H_

#include <core/multipleDispatch.hpp>

#include <automaton/Automaton.h>
#include <automaton/TA/DFTA.h>
#include <automaton/TA/NFTA.h>
#include <automaton/PDA/NPDA.h>
#include <automaton/PDA/DPDA.h>

namespace automaton {

namespace convert {

class ToPostfixPushdownAutomaton : public std::SingleDispatch < ToPostfixPushdownAutomaton, automaton::Automaton, const automaton::AutomatonBase & > {
public:
	/**
	 * Performs conversion.
	 * @return PDA equivalent to original finite tree automaton reading linearized postfix tree
	 */
	static automaton::Automaton convert ( const automaton::Automaton & automaton );

	static automaton::DPDA < > convert ( const automaton::DFTA < > & dfta );

	static automaton::NPDA < > convert ( const automaton::NFTA < > & nfta );

};

} /* namespace convert */

} /* namespace automaton */

#endif /* AUTOMATON_TO_AUTOMATON_H_ */
