/*
 * NFACommon.cpp
 *
 *  Created on: 16. 1. 2014
 *	  Author: Jan Vesely
 */

#include "NFACommon.h"
#include "common/DefaultStatesSetType.h"

#include <deque>
#include <algorithm>
#include <iostream>

namespace automaton {

namespace determinize {

DefaultStateType createDFAState ( std::set < DefaultStateType > nfaStates ) {
	return DefaultStateType ( DefaultStatesSetType ( std::move ( nfaStates ) ) );
}

const std::set < DefaultStateType > & recreateNFAStates ( const DefaultStateType & dfaState ) {
	 // std::cout << dfaState << std::endl;
	return static_cast < const DefaultStatesSetType & > ( dfaState.getData ( ) );
}

} /* namespace determinize */

} /* namespace automaton */
