/*
 * EpsilonClosure.cpp
 *
 *  Created on: 23. 3. 2014
 *	  Author: Tomas Pecka
 */

#include "EpsilonClosure.h"
#include <registration/AlgoRegistration.hpp>

namespace automaton {

namespace properties {

auto EpsilonClosureEpsilonNFA = registration::OverloadRegister < EpsilonClosure, std::set < DefaultStateType >, automaton::EpsilonNFA < > > ( EpsilonClosure::epsilonClosure );
auto EpsilonClosureMultiInitialStateNFA = registration::OverloadRegister < EpsilonClosure, std::set < DefaultStateType >, automaton::MultiInitialStateNFA < > > ( EpsilonClosure::epsilonClosure );
auto EpsilonClosureNFA = registration::OverloadRegister < EpsilonClosure, std::set < DefaultStateType >, automaton::NFA < > > ( EpsilonClosure::epsilonClosure );
auto EpsilonClosureDFA = registration::OverloadRegister < EpsilonClosure, std::set < DefaultStateType >, automaton::DFA < > > ( EpsilonClosure::epsilonClosure );
auto EpsilonClosureExtendedNFA = registration::OverloadRegister < EpsilonClosure, std::set < DefaultStateType >, automaton::ExtendedNFA < > > ( EpsilonClosure::epsilonClosure );
auto EpsilonClosureCompactNFA = registration::OverloadRegister < EpsilonClosure, std::set < DefaultStateType >, automaton::CompactNFA < > > ( EpsilonClosure::epsilonClosure );

std::set < DefaultStateType > EpsilonClosure::epsilonClosure(const Automaton& automaton, const DefaultStateType& q) {
	return dispatch(automaton.getData(), q);
}

} /* namespace properties */

} /* namespace automaton */

