/*
 * AutomatonIteration.cpp
 *
 *  Created on: 29. 11. 2014
 *	  Author: Tomas Pecka
 */

#include "AutomatonIteration.h"
#include <common/createUnique.hpp>
#include <registration/AlgoRegistration.hpp>

namespace automaton {

namespace transform {

automaton::Automaton AutomatonIteration::iteration(const automaton::Automaton& automaton) {
	return dispatch(automaton.getData());
}

auto AutomatonIterationDFA = registration::OverloadRegister < AutomatonIteration, automaton::NFA < >, automaton::DFA < > > ( AutomatonIteration::iteration );
auto AutomatonIterationNFA = registration::OverloadRegister < AutomatonIteration, automaton::NFA < >, automaton::NFA < > > ( AutomatonIteration::iteration );

} /* namespace transform */

} /* namespace automaton */
