/*
 * Reverse.cpp
 *
 *  Created on: 7. 11. 2014
 *	  Author: Tomas Pecka
 */

#include "Reverse.h"
#include <registration/AlgoRegistration.hpp>

namespace automaton {

namespace transform {

automaton::Automaton Reverse::convert(const Automaton& automaton) {
	return dispatch(automaton.getData());
}

auto ReverseDFA = registration::OverloadRegister < Reverse, automaton::MultiInitialStateNFA < >, automaton::DFA < > > ( Reverse::convert );
auto ReverseNFA = registration::OverloadRegister < Reverse, automaton::MultiInitialStateNFA < >, automaton::NFA < > > ( Reverse::convert );
auto ReverseMultiInitialStateNFA = registration::OverloadRegister < Reverse, automaton::MultiInitialStateNFA < >, automaton::MultiInitialStateNFA < > > ( Reverse::convert );

} /* namespace transform */

} /* namespace automaton */

