/*
 * UnreachableSymbols.cpp
 *
 *  Created on: 22. 3. 2014
 *	  Author: Tomas Pecka
 */

#include "UnreachableSymbols.h"
#include <registration/AlgoRegistration.hpp>

namespace grammar {

namespace properties {

auto UnreachableSymbolsCFG = registration::OverloadRegister < UnreachableSymbols, std::set < DefaultSymbolType >, grammar::CFG < > > ( UnreachableSymbols::getUnreachableSymbols );
auto UnreachableSymbolsEpsilonFreeCFG = registration::OverloadRegister < UnreachableSymbols, std::set < DefaultSymbolType >, grammar::EpsilonFreeCFG < > > ( UnreachableSymbols::getUnreachableSymbols );
auto UnreachableSymbolsGNF = registration::OverloadRegister < UnreachableSymbols, std::set < DefaultSymbolType >, grammar::GNF < > > ( UnreachableSymbols::getUnreachableSymbols );
auto UnreachableSymbolsCNF = registration::OverloadRegister < UnreachableSymbols, std::set < DefaultSymbolType >, grammar::CNF < > > ( UnreachableSymbols::getUnreachableSymbols );
auto UnreachableSymbolsLG = registration::OverloadRegister < UnreachableSymbols, std::set < DefaultSymbolType >, grammar::LG < > > ( UnreachableSymbols::getUnreachableSymbols );
auto UnreachableSymbolsLeftLG = registration::OverloadRegister < UnreachableSymbols, std::set < DefaultSymbolType >, grammar::LeftLG < > > ( UnreachableSymbols::getUnreachableSymbols );
auto UnreachableSymbolsLeftRG = registration::OverloadRegister < UnreachableSymbols, std::set < DefaultSymbolType >, grammar::LeftRG < > > ( UnreachableSymbols::getUnreachableSymbols );
auto UnreachableSymbolsRightLG = registration::OverloadRegister < UnreachableSymbols, std::set < DefaultSymbolType >, grammar::RightLG < > > ( UnreachableSymbols::getUnreachableSymbols );
auto UnreachableSymbolsRightRG = registration::OverloadRegister < UnreachableSymbols, std::set < DefaultSymbolType >, grammar::RightRG < > > ( UnreachableSymbols::getUnreachableSymbols );

std::set < DefaultSymbolType > UnreachableSymbols::getUnreachableSymbols ( const grammar::Grammar & grammar ) {
	return dispatch ( grammar.getData ( ) );
}

} /* namespace properties */

} /* namespace grammar */
