/*
 * EpsilonRemover.cpp
 *
 *  Created on: 24. 11. 2014
 *	  Author: Jan Travnicek
 */

#include "EpsilonRemover.h"
#include <registration/AlgoRegistration.hpp>

namespace grammar {

namespace simplify {

auto EpsilonRemoverCFG = registration::OverloadRegister < EpsilonRemover, grammar::EpsilonFreeCFG < >, grammar::CFG < > > ( EpsilonRemover::remove );
auto EpsilonRemoverEpsilonFreeCFG = registration::OverloadRegister < EpsilonRemover, grammar::EpsilonFreeCFG < >, grammar::EpsilonFreeCFG < > > ( EpsilonRemover::remove );
auto EpsilonRemoverCNF = registration::OverloadRegister < EpsilonRemover, grammar::CNF < >, grammar::CNF < > > ( EpsilonRemover::remove );
auto EpsilonRemoverGNF = registration::OverloadRegister < EpsilonRemover, grammar::GNF < >, grammar::GNF < > > ( EpsilonRemover::remove );
auto EpsilonRemoverLG = registration::OverloadRegister < EpsilonRemover, grammar::EpsilonFreeCFG < >, grammar::LG < > > ( EpsilonRemover::remove );
auto EpsilonRemoverLeftLG = registration::OverloadRegister < EpsilonRemover, grammar::EpsilonFreeCFG < >, grammar::LeftLG < > > ( EpsilonRemover::remove );
auto EpsilonRemoverLeftRG = registration::OverloadRegister < EpsilonRemover, grammar::LeftRG < >, grammar::LeftRG < > > ( EpsilonRemover::remove );
auto EpsilonRemoverRightLG = registration::OverloadRegister < EpsilonRemover, grammar::EpsilonFreeCFG < >, grammar::RightLG < > > ( EpsilonRemover::remove );
auto EpsilonRemoverRightRG = registration::OverloadRegister < EpsilonRemover, grammar::RightRG < >, grammar::RightRG < > > ( EpsilonRemover::remove );

grammar::Grammar EpsilonRemover::remove(const grammar::Grammar& grammar) {
	return dispatch(grammar.getData());
}

} /* namespace simplify */

} /* namespace grammar */
