/*
 * ToAutomaton.cpp
 *
 *  Created on: 11. 1. 2014
 *	  Author: Jan Travnicek
 */

#include "ToAutomaton.h"
#include <registration/AlgoRegistration.hpp>

namespace regexp {

namespace convert {

automaton::Automaton ToAutomaton::convert(const regexp::RegExp& regexp) {
	return dispatch(regexp.getData());
}

auto ToAutomatonFormalRegExp = registration::OverloadRegister < ToAutomaton, automaton::Automaton, regexp::FormalRegExp < > > ( ToAutomaton::convert );
auto ToAutomatonUnboundedRegExp = registration::OverloadRegister < ToAutomaton, automaton::Automaton, regexp::UnboundedRegExp < > > ( ToAutomaton::convert );

} /* namespace convert */

} /* namespace regexp */
