/*
 * RegExpOptimize.cpp
 *
 *  Created on: 20. 1. 2014
 *	  Author: Tomas Pecka
 */

#include "RegExpOptimize.h"
#include <registration/AlgoRegistration.hpp>

namespace regexp {

namespace simplify {

regexp::RegExp RegExpOptimize::optimize(const regexp::RegExp& regexp) {
	return dispatch(regexp.getData());
}

auto RegExpOptimizeFormalRegExp = registration::OverloadRegister < RegExpOptimize, FormalRegExp < >, FormalRegExp < > > ( RegExpOptimize::optimize );
auto RegExpOptimizeUnboundedRegExp = registration::OverloadRegister < RegExpOptimize, UnboundedRegExp < >, UnboundedRegExp < > > ( RegExpOptimize::optimize );

} /* namespace regexp */

} /* namespace simplify */
