/*
 * ExactMatchingAutomaton.cpp
 *
 *  Created on: 9. 2. 2014
 *      Author: Jan Travnicek
 */

#include "ExactMatchingAutomaton.h"
#include <string/LinearString.h>
#include <string/Epsilon.h>

#include <deque>
#include <registration/AlgoRegistration.hpp>

namespace stringology {

namespace matching {

automaton::Automaton ExactMatchingAutomaton::construct(const string::String& pattern) {
	return dispatch(pattern.getData());
}

auto ExactMatchingAutomatonLinearString = registration::OverloadRegister < ExactMatchingAutomaton, automaton::NFA < DefaultSymbolType, unsigned >, string::LinearString < > > ( ExactMatchingAutomaton::construct );

} /* namespace matching */

} /* namespace stringology */
