/*
 * SubtreeJumpTable.cpp
 *
 *  Created on: 5. 11. 2014
 *      Author: Jan Travnicek
 */

#include "SubtreeJumpTable.h"
#include <registration/AlgoRegistration.hpp>

namespace tree {

namespace properties {

std::vector < int > SubtreeJumpTable::compute ( const tree::RankedTreeWrapper & subject ) {
	return dispatch ( subject.getData ( ) );
}

auto SubtreeSizesPrefixRankedBarTree = registration::OverloadRegister < SubtreeJumpTable, std::vector < int >, tree::PrefixRankedBarTree < > > ( SubtreeJumpTable::compute );
auto SubtreeSizesPrefixRankedBarPattern = registration::OverloadRegister < SubtreeJumpTable, std::vector < int >, tree::PrefixRankedBarPattern < > > ( SubtreeJumpTable::compute );
auto SubtreeSizesPrefixRankedTree = registration::OverloadRegister < SubtreeJumpTable, std::vector < int >, tree::PrefixRankedTree < > > ( SubtreeJumpTable::compute );
auto SubtreeSizesPrefixRankedPattern = registration::OverloadRegister < SubtreeJumpTable, std::vector < int >, tree::PrefixRankedPattern < > > ( SubtreeJumpTable::compute );

} /* namespace properties */

} /* namespace tree */
