#include "ExactSuffixAutomatonTest.h"

#include "string/LinearString.h"
#include "stringology/indexing/ExactSuffixAutomaton.h"

CPPUNIT_TEST_SUITE_NAMED_REGISTRATION ( ExactSuffixAutomatonTest, "stringology" );
CPPUNIT_TEST_SUITE_REGISTRATION ( ExactSuffixAutomatonTest );

void ExactSuffixAutomatonTest::setUp ( ) {
}

void ExactSuffixAutomatonTest::tearDown ( ) {
}

void ExactSuffixAutomatonTest::testSuffixAutomatonConstruction ( ) {

	string::LinearString < > pattern ( "atatac" );

	automaton::DFA<> suffixAutomaton = stringology::indexing::ExactSuffixAutomaton::construct ( pattern );

	automaton::DFA<> refSuffixAutomaton ( DefaultStateType ( 0 ) );

	refSuffixAutomaton.setInputAlphabet ( pattern.getAlphabet ( ) );

	for ( int i = 1; i <= 6; ++i ) {
		refSuffixAutomaton.addState ( DefaultStateType ( i ) );
	}

	refSuffixAutomaton.addFinalState ( DefaultStateType ( 0 ) );
	refSuffixAutomaton.addFinalState ( DefaultStateType ( 6 ) );

	refSuffixAutomaton.addTransition ( DefaultStateType ( 0 ), DefaultSymbolType ( 'a' ), DefaultStateType ( 1 ) );
	refSuffixAutomaton.addTransition ( DefaultStateType ( 0 ), DefaultSymbolType ( 't' ), DefaultStateType ( 2 ) );
	refSuffixAutomaton.addTransition ( DefaultStateType ( 0 ), DefaultSymbolType ( 'c' ), DefaultStateType ( 6 ) );
	refSuffixAutomaton.addTransition ( DefaultStateType ( 1 ), DefaultSymbolType ( 't' ), DefaultStateType ( 2 ) );
	refSuffixAutomaton.addTransition ( DefaultStateType ( 1 ), DefaultSymbolType ( 'c' ), DefaultStateType ( 6 ) );
	refSuffixAutomaton.addTransition ( DefaultStateType ( 2 ), DefaultSymbolType ( 'a' ), DefaultStateType ( 3 ) );
	refSuffixAutomaton.addTransition ( DefaultStateType ( 3 ), DefaultSymbolType ( 't' ), DefaultStateType ( 4 ) );
	refSuffixAutomaton.addTransition ( DefaultStateType ( 3 ), DefaultSymbolType ( 'c' ), DefaultStateType ( 6 ) );
	refSuffixAutomaton.addTransition ( DefaultStateType ( 4 ), DefaultSymbolType ( 'a' ), DefaultStateType ( 5 ) );
	refSuffixAutomaton.addTransition ( DefaultStateType ( 5 ), DefaultSymbolType ( 'c' ), DefaultStateType ( 6 ) );

	std::cout << suffixAutomaton << std::endl;
	std::cout << refSuffixAutomaton << std::endl;

	CPPUNIT_ASSERT ( suffixAutomaton == refSuffixAutomaton );
}
