#ifndef _CLI_BINDED_FILE_RESULT_STATEMENT_H_
#define _CLI_BINDED_FILE_RESULT_STATEMENT_H_

#include <ast/Statement.h>

namespace cli {

class BindedFileResultStatement : public Statement {
	std::string m_bind;

public:
	BindedFileResultStatement ( std::string bind ) : m_bind ( bind ) {
	}

	virtual std::shared_ptr < abstraction::OperationAbstraction > translateAndEval ( const std::shared_ptr < abstraction::OperationAbstraction > & prev, Environment & environment ) const override {
		std::shared_ptr < abstraction::OperationAbstraction > res = prev->getXmlFileWriterFromResult ( environment.get ( m_bind ) );
		res->attachInput ( prev, 0 );
		res->eval ( );
		return res;
	}

};

} /* namespace cli */

#endif /* _CLI_BINDED_FILE_RESULT_STATEMENT_H_ */
