#ifndef _CLI_BINDED_PARAM_H_
#define _CLI_BINDED_PARAM_H_

#include <ast/Param.h>
#include <abstraction/Registry.h>

namespace cli {

class BindedParam : public Param {
	std::string m_bind;

public:
	BindedParam ( std::string bind ) : m_bind ( bind ) {
	}

	virtual std::shared_ptr < abstraction::OperationAbstraction > translateAndEval ( const std::shared_ptr < abstraction::OperationAbstraction > &, Environment & environment ) const override {
		return std::make_shared < abstraction::ImmediateValueAbstraction < std::string > > ( environment.get ( m_bind ) );
	}
};

} /* namespace cli */

#endif /* _CLI_BINDED_PARAM_H_ */
