#ifndef _CLI_CAST_STATEMENT_H_
#define _CLI_CAST_STATEMENT_H_

#include <ast/Statement.h>

namespace cli {

class CastStatement : public Statement {
	std::string m_type;
	std::shared_ptr < Statement > m_statement;

public:
	CastStatement ( std::string type, std::shared_ptr < Statement > statement ) : m_type ( std::move ( type ) ), m_statement ( statement ) {
	}

	virtual std::shared_ptr < abstraction::OperationAbstraction > translateAndEval ( const std::shared_ptr < abstraction::OperationAbstraction > & prev, Environment & environment ) const override {
		std::shared_ptr < abstraction::OperationAbstraction > translatedStatement = m_statement->translateAndEval ( prev, environment );

		std::shared_ptr < abstraction::OperationAbstraction > res = translatedStatement->getCastFromResult ( m_type );
		res->attachInput ( translatedStatement, 0 );
		res->eval ( );
		return res;
	}

};

} /* namespace cli */

#endif /* _CLI_CAST_STATEMENT_H_ */
