#ifndef _CLI_IMMEDIATE_FILE_PARAM_H_
#define _CLI_IMMEDIATE_FILE_PARAM_H_

#include <ast/Param.h>
#include <abstraction/Registry.h>

namespace cli {

class ImmediateFileParam : public Param {
	std::string m_name;

public:
	ImmediateFileParam ( std::string name ) : m_name ( name ) {
	}

	virtual std::shared_ptr < abstraction::OperationAbstraction > translateAndEval ( const std::shared_ptr < abstraction::OperationAbstraction > &, Environment & ) const override {
		std::deque < sax::Token > tokens = sax::FromXMLParserHelper::parseInput ( m_name );
		std::string type = tokens [ 0 ].getData ( );
		return abstraction::Registry::getXmlParserAbstraction ( type, tokens );
	}
};

} /* namespace cli */

#endif /* _CLI_IMMEDIATE_FILE_PARAM_H_ */
