#include <lexer/Lexer.h>

#include <cctype>

namespace cli {

Lexer::Token Lexer::nextToken () {
	Token res { "", TokenType::ERROR };

q0:		if ( m_index >= m_line.size ( ) ) {
		res.m_type = TokenType::END;
		return res;
	}
	if ( isspace ( m_line [ m_index ] ) ) {
		m_index ++;
		goto q0;
	}
	if ( m_line [ m_index ] == '<' ) {
		m_index ++;
		res.m_type = TokenType::IN_REDIRECT;
		return res;
	}
	if ( m_line [ m_index ] == '>' ) {
		m_index ++;
		res.m_type = TokenType::OUT_REDIRECT;
		return res;
	}
	if ( m_line [ m_index ] == '(' ) {
		m_index ++;
		res.m_type = TokenType::LEFT_PAREN;
		return res;
	}
	if ( m_line [ m_index ] == ')' ) {
		m_index ++;
		res.m_type = TokenType::RIGHT_PAREN;
		return res;
	}
	if ( m_line [ m_index ] == '$' ) {
		m_index ++;
		res.m_type = TokenType::DOLAR_SIGN;
		return res;
	}
	if ( m_line [ m_index ] == '&' ) {
		m_index ++;
		res.m_type = TokenType::AMPERSAND_SIGN;
		return res;
	}
	if ( m_line [ m_index ] == '|' ) {
		m_index ++;
		res.m_type = TokenType::PIPE_SIGN;
		return res;
	}
	if ( m_line [ m_index ] == ':' ) {
		m_index ++;
		res.m_type = TokenType::COLON_SIGN;
		return res;
	}
	if ( m_line [ m_index ] == '-' ) {
		res.m_value += m_line [ m_index ];
		m_index ++;
		goto q2;
	}

	if ( ( m_line [ m_index ] >= '0' && m_line [ m_index ] <= '9' ) ) {
		res.m_value += m_line [ m_index ];
		m_index++;
		goto q1;
	}

	if ( ( m_line [ m_index ] >= 'a' && m_line [ m_index ] <= 'z' )
	  || ( m_line [ m_index ] >= 'A' && m_line [ m_index ] <= 'Z' )
	  || ( m_line [ m_index ] == '/' || m_line [ m_index ] == '.' || m_line [ m_index ] == '~' || m_line [ m_index ] == '_' ) ) {
		res.m_value += m_line [ m_index ];
		m_index++;
		goto q3;
	}

	res.m_type = TokenType::ERROR;
	return res;

q1:	if ( m_index >= m_line.size ( ) ) {
		res.m_type = TokenType::INTEGER;
		return res;
	}
	if ( ( m_line [ m_index ] >= '0' && m_line [ m_index ] <= '9' ) ) {
		res.m_value += m_line [ m_index ];
		m_index++;
		goto q1;
	} else {
		res.m_type = TokenType::INTEGER;
		return res;
	}

q2:	if ( m_index >= m_line.size ( ) ) {
		res.m_value = "";
		res.m_type = TokenType::DASH_SIGN;
		return res;
	}
	if ( ( m_line [ m_index ] >= '0' && m_line [ m_index ] <= '9' ) ) {
		res.m_value += m_line [ m_index ];
		m_index++;
		goto q1;
	}

	if ( ( m_line [ m_index ] >= 'a' && m_line [ m_index ] <= 'z' )
	  || ( m_line [ m_index ] >= 'A' && m_line [ m_index ] <= 'Z' )
	  || ( m_line [ m_index ] == '/' || m_line [ m_index ] == '.' || m_line [ m_index ] == '~' || m_line [ m_index ] == '_' )
	  || m_line [ m_index ] == ':' ) {
		res.m_value += m_line [ m_index ];
		m_index++;
		goto q3;
	}

	res.m_value = "";
	res.m_type = TokenType::DASH_SIGN;
	return res;

q3:	if ( m_index >= m_line.size ( ) ) {
		res.m_type = is_kw ( res.m_value );
		return res;
	}
	if ( ( m_line [ m_index ] >= '0' && m_line [ m_index ] <= '9' )
	  || ( m_line [ m_index ] >= 'a' && m_line [ m_index ] <= 'z' )
	  || ( m_line [ m_index ] >= 'A' && m_line [ m_index ] <= 'Z' )
	  || ( m_line [ m_index ] == '/' || m_line [ m_index ] == '.' || m_line [ m_index ] == '~' || m_line [ m_index ] == '_' )
	  || m_line [ m_index ] == ':' ) {
		res.m_value += m_line [ m_index ];
		m_index++;
		goto q3;
	} else {
		res.m_type = is_kw ( res.m_value );
		return res;
	}
}

} /* namespace cli */
