/*
 * DowncastAbstraction.hpp
 *
 *  Created on: 11. 7. 2017
 *	  Author: Jan Travnicek
 */

#ifndef _DOWNCAST_ABSTRACTION_HPP_
#define _DOWNCAST_ABSTRACTION_HPP_

#include <abstraction/UnaryOperationAbstraction.hpp>
#include <memory>

namespace abstraction {

template < class ConcreteType, class BaseType >
class DowncastAbstraction : public UnaryOperationAbstraction < ConcreteType, BaseType > {
public:
	DowncastAbstraction ( ) {
	}

	virtual bool run ( ) override {
		if ( ! this->inputsReady ( ) )
			return false;

		if ( this->cached ( ) )
			return true;

		this->m_data = std::unique_ptr < ConcreteType > ( static_cast < ConcreteType * > ( this->m_param->getData ( ).clone ( ) ) );

		return true;
	}
};

} /* namespace abstraction */

#endif /* _DOWNCAST_ABSTRACTION_HPP_ */
