/*
 * NormalizeAbstraction.hpp
 *
 *  Created on: 11. 7. 2017
 *	  Author: Jan Travnicek
 */

#ifndef _NORMALIZE_ABSTRACTION_HPP_
#define _NORMALIZE_ABSTRACTION_HPP_

#include <abstraction/UnaryOperationAbstraction.hpp>
#include <tuple>

namespace abstraction {

template < class ReturnType, class ParamType >
class NormalizeAbstraction : public UnaryOperationAbstraction < ReturnType, ParamType > {
public:
	NormalizeAbstraction ( ) {
	}

	virtual bool run ( ) override {
		if ( ! this->inputsReady ( ) )
			return false;

		if ( this->cached ( ) )
			return true;

		this->m_data = std::unique_ptr < ReturnType > ( ( ReturnType * ) std::move ( this->m_param->getData ( ) ).normalize ( ) );

		return true;
	}
};

} /* namespace abstraction */

#endif /* _NORMALIZE_ABSTRACTION_HPP_ */
