/*
 * Registry.h
 *
 *  Created on: 10. 7. 2017
 *	  Author: Jan Travnicek
 */

#ifndef _REGISTRY_H_
#define _REGISTRY_H_

#include <abstraction/OperationAbstraction.hpp>

namespace abstraction {

class Registry {
public:
	static std::shared_ptr < abstraction::OperationAbstraction > getAlgorithmAbstraction ( std::string name, const std::vector < std::type_index > & paramTypes );
	static std::shared_ptr < abstraction::OperationAbstraction > getAlgorithmAbstraction ( std::string name, const std::vector < std::type_index > & paramTypes, bool & unwrap, bool & normalize );
	static std::shared_ptr < abstraction::OperationAbstraction > getCastAbstraction ( std::string target, std::string param );
	static std::shared_ptr < abstraction::OperationAbstraction > getImmediateAbstraction ( std::string result, std::string value );
	static std::shared_ptr < abstraction::OperationAbstraction > getNormalizeAbstraction ( std::string param );
	static std::shared_ptr < abstraction::OperationAbstraction > getDowncastAbstraction ( std::string concrete, std::string base );
	static std::shared_ptr < abstraction::OperationAbstraction > getValuePrinterAbstraction ( std::string param );
	static std::shared_ptr < abstraction::OperationAbstraction > getXmlFileWriterAbstraction ( std::string param, std::string filename );
	static std::shared_ptr < abstraction::OperationAbstraction > getXmlParserAbstraction ( std::string typeName, std::deque < sax::Token > tokens );
};

} /* namespace abstraction */

#endif /* _REGISTRY_H_ */

