/*
 * ValuePrinterAbstraction.hpp
 *
 *  Created on: 11. 7. 2017
 *	  Author: Jan Travnicek
 */

#ifndef _VALUE_PRINTER_ABSTRACTION_HPP_
#define _VALUE_PRINTER_ABSTRACTION_HPP_

#include <abstraction/UnaryOperationAbstraction.hpp>
#include <tuple>

namespace abstraction {

template < class ParamType >
class ValuePrinterAbstraction : public UnaryOperationAbstraction < void, ParamType > {
public:
	ValuePrinterAbstraction ( ) {
	}

	virtual bool run ( ) override {
		if ( ! this->inputsReady ( ) )
			return false;

		std::cout << this->m_param->getData ( );
		return true;
	}
};

} /* namespace abstraction */

#endif /* _VALUE_PRINTER_ABSTRACTION_HPP_ */
