/*
 * ContainerFeatures.h
 *
 *  Created on: Jun 19, 2014
 *      Author: Jan Travnicek
 */

#ifndef CONTAINER_FEATURES_H_
#define CONTAINER_FEATURES_H_

#include <object/Object.h>

namespace container {

enum class FEATURES {
	SET,
	VECTOR,
	PAIR,
	MAP
};

class Container;
class ContainerBase;

template < class ElementType = alib::Object >
class ObjectsDeque;
template < class ElementType = alib::Object >
class ObjectsList;
template < class KeyType = alib::Object, class ValueType = alib::Object >
class ObjectsMap;
template < class FirstType = alib::Object, class SecondType = alib::Object >
class ObjectsPair;
template < class ElementType = alib::Object >
class ObjectsSet;
template < class ElementType = alib::Object >
class ObjectsTree;
template < class KeyType = alib::Object, class ValueType = alib::Object >
class ObjectsTrie;
template < class ElementType = alib::Object >
class ObjectsVector;

} /* namespace container */

#endif /* CONTAINER_FEATURES_H_ */
