#include <list>
#include "ObjectTest.h"

#include "sax/SaxParseInterface.h"
#include "sax/SaxComposeInterface.h"

#include "object/Object.h"
#include <primitive/Unsigned.h>

#include <type_traits>

CPPUNIT_TEST_SUITE_NAMED_REGISTRATION ( ObjectTest, "object" );
CPPUNIT_TEST_SUITE_REGISTRATION ( ObjectTest );

void ObjectTest::setUp ( ) {
}

void ObjectTest::tearDown ( ) {
}

void ObjectTest::testProperties ( ) {
	CPPUNIT_ASSERT ( std::is_nothrow_move_constructible < alib::Object >::value );
	CPPUNIT_ASSERT ( std::is_move_constructible < alib::Object >::value && std::is_move_assignable < alib::Object >::value );

	alib::Object tmp1 { primitive::Unsigned ( 1 ) };
	alib::Object tmp2 { primitive::Unsigned ( 2 ) };

	std::swap ( tmp1, tmp2 );

	CPPUNIT_ASSERT ( tmp1 == alib::Object ( primitive::Unsigned ( 2 ) ) );
	CPPUNIT_ASSERT ( tmp2 == alib::Object ( primitive::Unsigned ( 1 ) ) );

}
