/*
 * BarSymbol.h
 *
 *  Created on: Apr 10, 2013
 *      Author: Stepan Plachy
 */

#include "BarSymbol.h"
#include <sax/FromXMLParserHelper.h>
#include "Symbol.h"
#include <object/Object.h>
#include <registration/TypeRegistration.hpp>
#include "UniqueSymbol.h"

namespace alphabet {

BarSymbol::BarSymbol() {

}

SymbolBase* BarSymbol::clone() const {
	return new BarSymbol(*this);
}

SymbolBase* BarSymbol::plunder() && {
	return new BarSymbol(std::move(*this));
}

int BarSymbol::compare(const BarSymbol&) const {
	return 0;
}

void BarSymbol::operator>>(std::ostream& out) const {
	out << "(Bar symbol)";
}

BarSymbol::operator std::string () const {
	return BarSymbol::instance < std::string > ( );
}

BarSymbol BarSymbol::parse(std::deque<sax::Token>::iterator& input) {
	sax::FromXMLParserHelper::popToken(input, sax::Token::TokenType::START_ELEMENT, BarSymbol::getXmlTagName());
	sax::FromXMLParserHelper::popToken(input, sax::Token::TokenType::END_ELEMENT, BarSymbol::getXmlTagName());
	return BarSymbol();
}

void BarSymbol::compose(std::deque<sax::Token>& out) const {
	out.emplace_back(BarSymbol::getXmlTagName(), sax::Token::TokenType::START_ELEMENT);
	out.emplace_back(BarSymbol::getXmlTagName(), sax::Token::TokenType::END_ELEMENT);
}

SymbolBase* BarSymbol::inc() && {
	return new UniqueSymbol(Symbol(std::move(*this)), primitive::Integer(0));
}

} /* namespace alphabet */

namespace alib {

auto barSymbolType = registration::TypeRegister < alphabet::Symbol, alphabet::BarSymbol > ();
auto barSymbolType2 = registration::TypeRegister < alib::Object, alphabet::BarSymbol > ();

} /* namespace alib */
