/*
 * GrammarBase.h
 *
 *  Created on: Apr 10, 2013
 *      Author: Jan Travnicek
 */

#ifndef GRAMMAR_BASE_H_
#define GRAMMAR_BASE_H_

#include <object/ObjectBase.h>

namespace grammar {

/**
 * \brief Represents base for a concrete grammar type.
 */
class GrammarBase : public alib::ObjectBase {
public:
	/**
	 * @copydoc alib::ObjectBase::clone()
	 */
	virtual GrammarBase* clone() const override = 0;

	/**
	 * @copydoc alib::ObjectBase::plunder()
	 */
	virtual GrammarBase* plunder() && override = 0;

	/**
	 * @copydoc alib::ObjectBase::normalize()
	 */
	virtual GrammarBase* normalize ( ) && override = 0;
};

} /* namespace grammar */

#endif /* GRAMMAR_BASE_H_ */
