/*
 * RegExpFeatures.h
 *
 *  Created on: Jun 19, 2014
 *      Author: Jan Travnicek
 */

#ifndef REG_EXP_FEATURES_H_
#define REG_EXP_FEATURES_H_

#include <common/DefaultSymbolType.h>

namespace regexp {

enum class FEATURES {
	FORMAL,
	UNBOUNDED
};

class RegExp;
class RegExpBase;

template < class SymbolType = DefaultSymbolType >
class UnboundedRegExp;
template < class SymbolType >
class UnboundedRegExpStructure;

template < class SymbolType >
class UnboundedRegExpElement;
template < class SymbolType >
class UnboundedRegExpAlternation;
template < class SymbolType >
class UnboundedRegExpConcatenation;
template < class SymbolType >
class UnboundedRegExpIteration;
template < class SymbolType >
class UnboundedRegExpSymbol;
template < class SymbolType >
class UnboundedRegExpEmpty;
template < class SymbolType >
class UnboundedRegExpEpsilon;


template < class SymbolType = DefaultSymbolType >
class FormalRegExp;
template < class SymbolType >
class FormalRegExpStructure;

template < class SymbolType >
class FormalRegExpElement;
template < class SymbolType >
class FormalRegExpAlternation;
template < class SymbolType >
class FormalRegExpConcatenation;
template < class SymbolType >
class FormalRegExpIteration;
template < class SymbolType >
class FormalRegExpSymbol;
template < class SymbolType >
class FormalRegExpEmpty;
template < class SymbolType >
class FormalRegExpEpsilon;

} /* namespace regexp */

#endif /* REG_EXP_FEATURES_H_ */
