/*
 * RTEBase.h
 *
 *  Created on: Feb 1, 2016
 *      Author: Tomas Pecka
 */

#ifndef RTE_BASE_H_
#define RTE_BASE_H_

#include <object/ObjectBase.h>
#include <set>
#include <alphabet/ranked_symbol.hpp>

namespace rte {

class RTEBase : public alib::ObjectBase {
public:
	virtual RTEBase * clone ( ) const = 0;
	virtual RTEBase * plunder ( ) &&  = 0;

	virtual const std::set < std::ranked_symbol < > > & getAlphabet ( ) const = 0;
	virtual const std::set < std::ranked_symbol < > > & getSubstitutionAlphabet ( ) const = 0;

	virtual RTEBase* normalize ( ) && = 0;
};

} /* namespace rte */

#endif /* RTE_BASE_H_ */
