/*
 * FormalRTESymbol.h
 *
 *  Created on: Feb 20, 2016
 *      Author: Tomas Pecka
 */

#ifndef FORMAL_RTE_SYMBOL_H_
#define FORMAL_RTE_SYMBOL_H_

#include <alphabet/ranked_symbol.hpp>
#include "FormalRTEElement.h"

namespace rte {

/**
 * Represents symbol, abstract class
 */
template < class SymbolType, class RankType >
class FormalRTESymbol : public FormalRTEElement < SymbolType, RankType > {
protected:
	std::ranked_symbol < SymbolType, RankType > m_symbol;

public:
	FormalRTESymbol ( std::ranked_symbol < SymbolType, RankType > symbol );

	/**
	 * @copydoc FormalRTEElement::clone() const
	 */
	virtual FormalRTESymbol < SymbolType, RankType > * clone ( ) const override = 0;

	/**
	 * @copydoc FormalRTEElement::plunder() const
	 */
	virtual FormalRTESymbol < SymbolType, RankType > * plunder ( ) && override = 0;

	const std::ranked_symbol < SymbolType, RankType > & getSymbol ( ) const;

	virtual std::smart_ptr < FormalRTESymbol < DefaultSymbolType, DefaultRankType > > normalizeSymbol ( ) && = 0;
};

template < class SymbolType, class RankType >
FormalRTESymbol < SymbolType, RankType >::FormalRTESymbol ( std::ranked_symbol < SymbolType, RankType > symbol ) : m_symbol ( std::move ( symbol ) ) {
}

template < class SymbolType, class RankType >
const std::ranked_symbol < SymbolType, RankType > & FormalRTESymbol < SymbolType, RankType >::getSymbol ( ) const {
	return m_symbol;
}

} /* namespace rte */

#endif /* FORMAL_RTE_SYMBOL_H_ */
