/*
 * LinearString.cpp
 *
 *  Created on: Nov 23, 2013
 *      Author: Jan Travnicek
 */

#include "LinearString.h"

#include "String.h"
#include <object/Object.h>
#include <registration/TypeRegistration.hpp>
#include <registration/CastRegistration.hpp>
#include <registration/NameRegistration.hpp>

namespace alib {

auto linearStringType = registration::TypeRegister < string::String, string::LinearString < > > ( );
auto linearStringType2 = registration::TypeRegister < alib::Object, string::LinearString < > > ( );

auto LinearStringFromEpsilon = registration::CastRegister < string::LinearString < >, string::Epsilon < > > ( );
auto LinearStringFromPrefixBarTree = registration::CastRegister < string::LinearString < >, tree::PrefixBarTree < > > ( );

auto LinearStringFromPrefixRankedTree = registration::CastRegister < string::LinearString < std::ranked_symbol < DefaultSymbolType, DefaultRankType > >, tree::PrefixRankedTree < > > ( );
auto LinearStringFromPrefixRankedPattern = registration::CastRegister < string::LinearString < std::ranked_symbol < DefaultSymbolType, DefaultRankType > >, tree::PrefixRankedPattern < > > ( );
auto LinearStringFromPrefixRankedNonlinearPattern = registration::CastRegister < string::LinearString < std::ranked_symbol < DefaultSymbolType, DefaultRankType > >, tree::PrefixRankedNonlinearPattern < > > ( );
auto LinearStringFromPrefixRankedBarTree = registration::CastRegister < string::LinearString < std::ranked_symbol < DefaultSymbolType, DefaultRankType > >, tree::PrefixRankedBarTree < > > ( );
auto LinearStringFromPrefixRankedBarPattern = registration::CastRegister < string::LinearString < std::ranked_symbol < DefaultSymbolType, DefaultRankType > >, tree::PrefixRankedBarPattern < > > ( );
auto LinearStringFromPrefixRankedBarNonlinearPattern = registration::CastRegister < string::LinearString < std::ranked_symbol < DefaultSymbolType, DefaultRankType > >, tree::PrefixRankedBarNonlinearPattern < > > ( );

auto LinearStringName = registration::NameRegister < string::LinearString < > > ( string::LinearString < >::getXmlTagName ( ) );
auto LinearStringName2 = registration::NameRegister < string::LinearString < std::ranked_symbol < DefaultSymbolType, DefaultRankType > > > ( string::LinearString < >::getXmlTagName ( ) );

} /* namespace alib */
