/*
 * PostfixRankedTree.cpp
 *
 *  Created on: May 4, 2017
 *      Author: Aleksandr Shatrovskii
 */

#include "PostfixRankedTree.h"
#include "../Tree.h"
#include "../RankedTreeWrapper.h"
#include <object/Object.h>
#include <registration/TypeRegistration.hpp>
#include <registration/CastRegistration.hpp>
#include <registration/NameRegistration.hpp>

namespace alib {

auto postfixRankedTreeType = registration::TypeRegister < tree::Tree, tree::PostfixRankedTree < > > ( );
auto postfixRankedTreeType2 = registration::TypeRegister < tree::RankedTreeWrapper, tree::PostfixRankedTree < > > ( );
auto postfixRankedTreeType3 = registration::TypeRegister < alib::Object, tree::PostfixRankedTree < > > ( );

auto PostfixRankedTreeFromRankedTree = registration::CastRegister < tree::PostfixRankedTree < >, tree::RankedTree < > > ( );

auto PostfixRankedTreeName = registration::NameRegister < tree::PostfixRankedTree < > > ( tree::PostfixRankedTree < >::getXmlTagName ( ) );

} /* namespace alib */
