/*
 * PrefixRankedNonlinearPattern.cpp
 *
 *  Created on: Jul 20, 2016
 *      Author: Jan Travnicek
 */

#include "PrefixRankedNonlinearPattern.h"
#include "../Tree.h"
#include "../RankedTreeWrapper.h"
#include <object/Object.h>
#include <registration/TypeRegistration.hpp>
#include <registration/CastRegistration.hpp>
#include <registration/NameRegistration.hpp>

namespace alib {

auto prefixRankedNonlinearPatternType = registration::TypeRegister < tree::Tree, tree::PrefixRankedNonlinearPattern < > > ( );
auto prefixRankedNonlinearPatternType2 = registration::TypeRegister < tree::RankedTreeWrapper, tree::PrefixRankedNonlinearPattern < > > ( );
auto prefixRankedNonlinearPatternType3 = registration::TypeRegister < alib::Object, tree::PrefixRankedNonlinearPattern < > > ( );

auto PrefixRankedNonlinearPatternFromRankedTree = registration::CastRegister < tree::PrefixRankedNonlinearPattern < >, tree::RankedTree < > > ( );
auto PrefixRankedNonlinearPatternFromRankedPattern = registration::CastRegister < tree::PrefixRankedNonlinearPattern < >, tree::RankedPattern < > > ( );
auto PrefixRankedNonlinearPatternFromRankedNonlinearPattern = registration::CastRegister < tree::PrefixRankedNonlinearPattern < >, tree::RankedNonlinearPattern < > > ( );
auto PrefixRankedNonlinearPatternFromPrefixRankedTree = registration::CastRegister < tree::PrefixRankedNonlinearPattern < >, tree::PrefixRankedTree < > > ( );
auto PrefixRankedNonlinearPatternFromPrefixRankedPattern = registration::CastRegister < tree::PrefixRankedNonlinearPattern < >, tree::PrefixRankedPattern < > > ( );

auto PrefixRankedNonlinearPatternName = registration::NameRegister < tree::PrefixRankedNonlinearPattern < > > ( tree::PrefixRankedNonlinearPattern < >::getXmlTagName ( ) );

} /* namespace alib */
