/*
 * RankedPattern.cpp
 *
 *  Created on: Nov 23, 2013
 *      Author: Jan Travnicek
 */

#include "RankedPattern.h"
#include "../Tree.h"
#include "../RankedTreeWrapper.h"
#include <object/Object.h>
#include <registration/TypeRegistration.hpp>
#include <registration/CastRegistration.hpp>
#include <registration/NameRegistration.hpp>

namespace alib {

auto rankedPatternType = registration::TypeRegister < tree::Tree, tree::RankedPattern < > > ( );
auto rankedPatternType2 = registration::TypeRegister < tree::RankedTreeWrapper, tree::RankedPattern < > > ( );
auto rankedPatternType3 = registration::TypeRegister < alib::Object, tree::RankedPattern < > > ( );

auto RankedPatternFromUnrankedPattern = registration::CastRegister < tree::RankedPattern < >, tree::UnrankedPattern < > > ( );

auto RankedPatternName = registration::NameRegister < tree::RankedPattern < > > ( tree::RankedPattern < >::getXmlTagName ( ) );

} /* namespace alib */
