/*
 * GraphTypes.cpp
 *
 *  Created on: Mar 16, 2016
 *      Author: Jan Broz
 */

#include "GraphTypes.h"

namespace graph {

std::string typeToString( GRAPH_TYPE t )
{
	switch (t) {
	 case GRAPH_TYPE::UNDIRECTED:
		return "Undirected";
	 case GRAPH_TYPE::DIRECTED:
		return "Directed";
	 default:
		return "Undirected";
	}
}

GRAPH_TYPE typeFromString( const std::string & str )
{
	if (str == "Undirected")
		return GRAPH_TYPE::UNDIRECTED;
	else if (str == "Directed")
		return GRAPH_TYPE::DIRECTED;
	else
		return GRAPH_TYPE::UNDIRECTED;
}

std::string representationToString( REPRESENTATION r )
{
	// !! add graph types/representations
	switch (r) {
	 case REPRESENTATION::ADJACENCY_LIST:
		return "AdjacencyList";
	 case REPRESENTATION::ADJACENCY_MATRIX:
		return "AdjacencyMatrix";
	 case REPRESENTATION::INCIDENCE_MATRIX:
		return "IncidenceMatrix";
	 default:
		return "AdjacencyList";
	}
}

REPRESENTATION representationFromString( const std::string & str )
{
	// !! add graph types/representations
	if (str == "AdjacencyList")
		return REPRESENTATION::ADJACENCY_LIST;
	else if (str == "AdjacencyMatrix")
		return REPRESENTATION::ADJACENCY_MATRIX;
	else if (str == "IncidenceMatrix")
		return REPRESENTATION::INCIDENCE_MATRIX;
	else
		return REPRESENTATION::ADJACENCY_LIST;
}

} // namespace graph
