/*
 * GraphTest.h
 *
 *   Created on: Jun 19, 2014
 *       Author: David Rosca
 */

#ifndef GRAPH_TEST_H_
#define GRAPH_TEST_H_

#include <cppunit/extensions/HelperMacros.h>


class GraphTest : public CppUnit::TestFixture
{
	CPPUNIT_TEST_SUITE(GraphTest);
	CPPUNIT_TEST(testCopyConstruct);
	CPPUNIT_TEST(testEqual);
	CPPUNIT_TEST(testXMLParser);
	CPPUNIT_TEST(testAddEdge);
	CPPUNIT_TEST(testRemoveEdge);
	CPPUNIT_TEST(testAddNode);
	CPPUNIT_TEST(testRemoveNode);
	CPPUNIT_TEST(testNeighborEdges);
	CPPUNIT_TEST(testHasEdge);
	CPPUNIT_TEST(testAddEdgeValue);
	CPPUNIT_TEST(testHasNodeAndEdge);
	CPPUNIT_TEST_SUITE_END();

public:
	void testCopyConstruct();
	void testEqual();
	void testXMLParser();

	void testAddEdge();
	void testRemoveEdge();
	void testAddNode();
	void testRemoveNode();
	void testNeighborEdges();
	void testHasEdge();
	void testAddEdgeValue();
	void testHasNodeAndEdge();
};

#endif	// GRAPH_TEST_H_
