/*
 * ReachableStates.cpp
 *
 *  Created on: 23. 3. 2014
 *	  Author: Tomas Pecka
 */

#include "ReachableStates.h"
#include <registration/AlgoRegistration.hpp>

namespace automaton {

namespace properties {

namespace efficient {

std::set<DefaultStateType> ReachableStates::reachableStates(const Automaton& automaton) {
	return dispatch(automaton.getData());
}

auto ReachableStatesEpsilonNFA = registration::OverloadRegister < ReachableStates, std::set < DefaultStateType >, automaton::EpsilonNFA < > > ( ReachableStates::reachableStates );
auto ReachableStatesNFA = registration::OverloadRegister < ReachableStates, std::set < DefaultStateType >, automaton::NFA < > > ( ReachableStates::reachableStates );
auto ReachableStatesCompactNFA = registration::OverloadRegister < ReachableStates, std::set < DefaultStateType >, automaton::CompactNFA < > > ( ReachableStates::reachableStates );
auto ReachableStatesExtendedNFA = registration::OverloadRegister < ReachableStates, std::set < DefaultStateType >, automaton::ExtendedNFA < > > ( ReachableStates::reachableStates );
auto ReachableStatesMultiInitialStateNFA = registration::OverloadRegister < ReachableStates, std::set < DefaultStateType >, automaton::MultiInitialStateNFA < > > ( ReachableStates::reachableStates );
auto ReachableStatesDFA = registration::OverloadRegister < ReachableStates, std::set < DefaultStateType >, automaton::DFA < > > ( ReachableStates::reachableStates );

} /* namespace efficient */

} /* namespace properties */

} /* namespace automaton */

