/*
 * Author: Radovan Cerveny
 */

#ifndef MEASUREMENT_PROVISIONER_CONFIGURATION_HPP_
#define MEASUREMENT_PROVISIONER_CONFIGURATION_HPP_

#include <vector>
#include <string>
#include <map>

namespace measurements {

struct MPCInputDatum {
	enum class Type {
		FILE, GENERATOR
	};

	Type		type;
	int			id;
	int			count;
	std::string value;
	std::string alias;
};

struct MPCInputBatch {
	std::vector < MPCInputDatum > batch;
	bool						  forcedDependencyBatch;
};

struct MPCPipelineCommand {
	std::string command;
	std::string alias;
	bool		measure;
};

using MPCPipeline = std::vector < MPCPipelineCommand >;

struct MPCEnvironment {
	std::string workingDirectory;
	int			pipelineIterations;
};

struct MeasurementProvisionerConfiguration {
	MPCEnvironment				  environment;
	std::vector < MPCInputBatch > inputBatches;
	std::vector < MPCPipeline >	  pipelines;
};

}

#endif /* MEASUREMENT_PROVISIONER_CONFIGURATION_HPP_ */
