/*
 * bitset.hpp
 *
 * Created on: May 04, 2017
 * Author: Jan Travnicek
 */

#ifndef __BITSET_HPP_
#define __BITSET_HPP_

#include <bitset>
#include <ostream>
#include <string>
#include <sstream>

#include "compare.hpp"

namespace std {

template < size_t N >
std::ostream & operator << ( std::ostream & out, const std::bitset < N > & bitset ) {
	out << "[";

	for ( size_t i = 0; i < N; ++i ) {
		if ( i != 0 ) out << ", ";
		out << bitset [ i ];
	}

	out << "]";
	return out;
}

template < size_t N >
struct compare < bitset < N > > {
	int operator ( ) ( const bitset < N > & first, const bitset < N > & second ) const {
		for ( size_t i = 0; i < N; ++i ) {
			int res = first [ i ] != second [ i ];
			if ( res != 0 )
				return res;
		}
		return 0;
	}
};

template < size_t N >
string to_string ( const std::bitset < N > & value ) {
	std::stringstream ss;
	ss << value;
	return ss.str ( );
}

} /* namespace std */

#endif /* __BITSET_HPP_ */
