/*
 * typeindex.cpp
 *
 * Created on: Jul 4, 2017
 * Author: Jan Travnicek
 */

#include <typeindex>
#include <string>
#include <cstdlib>
#include <cxxabi.h>

namespace std {

std::ostream & operator << ( std::ostream & os, const std::type_index & type ) {
	os << type.name ( );
	return os;
}

string type_name(const std::type_index& type) {
	int status;

	char* demangled = abi::__cxa_demangle(type.name(), 0, 0, &status);
	string res ( demangled );
	free ( demangled );
	return res;
}

} /* namespace std */
