/*
 * typeinfo.hpp
 *
 * Created on: Apr 1, 2013
 * Author: Jan Travnicek
 */

#ifndef __TYPEINFO_HPP_
#define __TYPEINFO_HPP_

#include <typeinfo>
#include <typeindex>
#include <string>
#include <cstdio>
#include <cstring>

namespace std {

	string type_name(const std::type_info& type);

	template <class T>
	string type_name() {
		return type_name(typeid(T));
	}

	template<typename T>
	bool is_same_type(const char* name) {
		char namespaceId[100];
		char classId[100];
		string ret = type_name<T>();
		sscanf(ret.c_str(), "%[a-zA-Z]::%[a-zA-Z]", namespaceId, classId);

		if(strcmp(classId, name) == 0) {
			return true;
		} else {
			return false;
		}
	}

	std::ostream & operator << ( std::ostream & os, const std::type_info & type );
}

#endif /* __TYPEINFO_HPP_ */
