#ifndef TRIE_TEST_H_
#define TRIE_TEST_H_

#include <cppunit/extensions/HelperMacros.h>
#include <compare>
#include <trie>

class TrieTest : public CppUnit::TestFixture {
	CPPUNIT_TEST_SUITE ( TrieTest );
	CPPUNIT_TEST ( testTrieStdStructure );
	CPPUNIT_TEST_SUITE_END ( );

public:
	struct RankedArityChecker {
		bool operator ()( char symbol, unsigned wantedRank ) const {
			switch ( symbol ) {
			case 'a':
				return wantedRank == 2;

			case 'b':
				return wantedRank == 1;

			default:
				return wantedRank == 0;
			}
		}

	};

	void print_tree ( const std::trie < char, int > & trie, std::string indent );

	void setUp ( );
	void tearDown ( );

	void testTrieStdStructure();
};

#endif // TRIE_TEST_H_
