/*
 * RegExpToStringComposer.cpp
 *
 *  Created on: Nov 23, 2013
 *      Author: Martin Zak
 */

#include "RegExpToStringComposer.h"
#include <registration/AlgoRegistration.hpp>

namespace regexp {

template < class SymbolType >
void RegExpToStringComposer::compose(std::ostream& output, const UnboundedRegExp < SymbolType > & regexp) {
	RegExpToStringComposer::compose ( output, regexp.getRegExp ( ) );
}

auto RegExpToStringComposerUnboundedRegExp = registration::OverloadRegister < RegExpToStringComposer, void, UnboundedRegExp < > >(RegExpToStringComposer::compose);
auto ObjectToStringComposerUnboundedRegExp = registration::OverloadRegister < alib::ObjectBaseDispatcher, void, UnboundedRegExp < > >( RegExpToStringComposer::compose);

template < class SymbolType >
void RegExpToStringComposer::compose(std::ostream& output, const FormalRegExp < SymbolType > & regexp) {
	RegExpToStringComposer::compose ( output, regexp.getRegExp ( ) );
}

auto RegExpToStringComposerFormalRegExp = registration::OverloadRegister < RegExpToStringComposer, void, FormalRegExp < > >(RegExpToStringComposer::compose);
auto ObjectToStringComposerFormalRegExp = registration::OverloadRegister < alib::ObjectBaseDispatcher, void, FormalRegExp < > >( RegExpToStringComposer::compose);

void RegExpToStringComposer::compose(std::ostream& output, const RegExp& regexp) {
	dispatch(output, regexp.getData());
}

auto ObjectToStringComposerRegExp = registration::OverloadRegister < alib::WrapperBaseDispatcher, void, RegExp>(RegExpToStringComposer::compose);

} /* namespace regexp */
