#include <list>
#include "RegExpTest.h"

#include "sax/SaxParseInterface.h"
#include "sax/SaxComposeInterface.h"

#include "regexp/unbounded/UnboundedRegExp.h"
#include "regexp/unbounded/UnboundedRegExpElements.h"
#include "regexp/formal/FormalRegExp.h"
#include "regexp/formal/FormalRegExpElements.h"
#include <regexp/RegExp.h>

#include "factory/XmlDataFactory.hpp"
#include "factory/StringDataFactory.hpp"

CPPUNIT_TEST_SUITE_NAMED_REGISTRATION( RegExpTest, "regexp" );
CPPUNIT_TEST_SUITE_REGISTRATION( RegExpTest );

void RegExpTest::setUp() {
}

void RegExpTest::tearDown() {
}

void RegExpTest::testEqual() {
	{
		std::string input = "#E* #0*";
		regexp::RegExp regexp = alib::StringDataFactory::fromString (input);

		std::string output = alib::StringDataFactory::toString(regexp);

		CPPUNIT_ASSERT( input == output );

		regexp::RegExp regexp2 = alib::StringDataFactory::fromString (output);

		CPPUNIT_ASSERT( regexp == regexp2 );
	}
	{
		std::string input = "a+a";
		regexp::RegExp regexp = alib::StringDataFactory::fromString (input);

		std::string output = alib::StringDataFactory::toString(regexp);

		CPPUNIT_ASSERT( input == output );

		regexp::RegExp regexp2 = alib::StringDataFactory::fromString (output);

		CPPUNIT_ASSERT( regexp == regexp2 );
	}
	{
		std::string input = "a+a (b+a)*";
		regexp::RegExp regexp = alib::StringDataFactory::fromString (input);

		std::string output = alib::StringDataFactory::toString(regexp);

		CPPUNIT_ASSERT( input == output );
		std::cout << output << std::endl;

		regexp::RegExp regexp2 = alib::StringDataFactory::fromString (output);

		CPPUNIT_ASSERT( regexp == regexp2 );
	}
}

