#include <list>
#include "StringTest.h"

#include "sax/SaxParseInterface.h"
#include "sax/SaxComposeInterface.h"

#include "string/String.h"
#include "string/LinearString.h"
#include "string/CyclicString.h"
#include "string/Epsilon.h"

#include "factory/XmlDataFactory.hpp"
#include "factory/StringDataFactory.hpp"

#include "alphabet/Symbol.h"
#include "alphabet/LabeledSymbol.h"
#include "alphabet/BlankSymbol.h"

CPPUNIT_TEST_SUITE_NAMED_REGISTRATION( StringTest, "string" );
CPPUNIT_TEST_SUITE_REGISTRATION( StringTest );

void StringTest::setUp() {
}

void StringTest::tearDown() {
}

void StringTest::testEqual() {
	{
		std::string input = "\"aa\"";
		string::String string = alib::StringDataFactory::fromString (input);

		std::string output = alib::StringDataFactory::toString(string);

		CPPUNIT_ASSERT( input == output );

		string::String string2 = alib::StringDataFactory::fromString (output);

		CPPUNIT_ASSERT( string == string2 );
	}
	{
		std::string input = "\"aaaa aaa\"";
		string::String string = alib::StringDataFactory::fromString (input);

		std::string output = alib::StringDataFactory::toString(string);

		std::cout << output << std::endl;

		CPPUNIT_ASSERT( input == output );

		string::String string2 = alib::StringDataFactory::fromString (output);

		CPPUNIT_ASSERT( string == string2 );
	}
	{
		std::string input = "#E";
		string::String string = alib::StringDataFactory::fromString (input);

		std::string output = alib::StringDataFactory::toString(string);

		CPPUNIT_ASSERT( input == output );

		string::String string2 = alib::StringDataFactory::fromString (output);

		CPPUNIT_ASSERT( string == string2 );
	}
}

