/*
 * Prompt.h
 *
 *  Created on: 20. 3. 2017
 *	  Author: Jan Travnicek
 */

#ifndef _AQL_PROMPT_H_
#define _AQL_PROMPT_H_

#include <string>
#include <parser/Parser.h>

class Prompt {
	Prompt ( const Prompt & ) = delete;
	Prompt ( Prompt && ) = delete;
	Prompt & operator = ( const Prompt & ) = delete;
	Prompt & operator = ( Prompt && ) = delete;

	std::string m_prefix;
	bool m_active;
	int m_exec_result;

	cli::Environment m_environment;

	char * stripwhite ( char * begin );

public:
	Prompt ( cli::Environment environment );

	int run ( );
	int execute_line ( std::string line );
};

#endif /* _AQL_PROMPT_H_ */
